# Hyperbolic functions

xtensor provides the following hyperbolic functions for xexpressions:

Defined in `xtensor/xmath.hpp`

template<class E>
inline auto xt::sinh(E &&e) noexcept -> detail::xfunction_type_t<math::sinh_fun, E>

  Hyperbolic sine function.

  Returns an xfunction for the element-wise hyperbolic sine of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::cosh(E &&e) noexcept -> detail::xfunction_type_t<math::cosh_fun, E>

  Hyperbolic cosine function.

  Returns an xfunction for the element-wise hyperbolic cosine of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::tanh(E &&e) noexcept -> detail::xfunction_type_t<math::tanh_fun, E>

  Hyperbolic tangent function.

  Returns an xfunction for the element-wise hyperbolic tangent of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::asinh(E &&e) noexcept -> detail::xfunction_type_t<math::asinh_fun, E>

  Inverse hyperbolic sine function.

  Returns an xfunction for the element-wise inverse hyperbolic sine of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::acosh(E &&e) noexcept -> detail::xfunction_type_t<math::acosh_fun, E>

  Inverse hyperbolic cosine function.

  Returns an xfunction for the element-wise inverse hyperbolic cosine of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::atanh(E &&e) noexcept -> detail::xfunction_type_t<math::atanh_fun, E>

  Inverse hyperbolic tangent function.

  Returns an xfunction for the element-wise inverse hyperbolic tangent of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction